"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFilepaths = getFilepaths;
exports.getSources = getSources;

var _fs = require("fs");

var _constants = require("./constants");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function getFilepaths(src, relFile, resolve) {
  var imports = src.split(_constants.newlinePattern).filter(function (line) {
    return line.startsWith('#import');
  });
  return imports.map(function (statement) {
    var importPath = statement.split(/[\s\n]+/g)[1].slice(1, -1);
    return resolve(importPath, relFile);
  });
}

function getSources(filepath, resolve) {
  var acc = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var importSrc = (0, _fs.readFileSync)(filepath.replace(/'/g, '')).toString();
  var nestedPaths = getFilepaths(importSrc, filepath, resolve);
  var srcs = nestedPaths.length > 0 ? _toConsumableArray(nestedPaths.reduce(function (srcArr, fp) {
    return _toConsumableArray(srcArr).concat(_toConsumableArray(getSources(fp, resolve, [])));
  }, [])).concat([importSrc]) : [importSrc];
  return _toConsumableArray(srcs).concat(_toConsumableArray(acc));
}